# debug dans emacs
# lancer l'emulateur
# wine "C:\Program Files (x86)\CASIO\fx-CG Manager PLUS Subscription for fx-CG50series\fx-CG_Manager_PLUS_Subscription_for_fx-CG50series.exe" /n"fx-CG Manager PLUS Subscription for fx-CG50series"
# sh3eb-elf-gdb -i=mi -ex "target remote localhost:31188" khicasm.elf
CXX	= sh3eb-elf-g++
AR	= sh3eb-elf-gcc-ar
RANLIB	= sh3eb-elf-gcc-ranlib
OBJCOPY = sh3eb-elf-objcopy

RM	= /bin/rm

# if -DGINT_MALLOC, define GINT_MALLOC in stdlib.c (or Makefile there) and rm kgen.o main.o
FLTO = # -flto # does not work for 2 addins
CXXFLAGS = -Os -mb -m4a-nofpu  -mhitachi -std=c++11 -fpermissive $(FLTO) -fno-use-cxa-atexit -fno-threadsafe-statics -fno-strict-aliasing -fno-rtti -fno-exceptions -DHAVE_CONFIG_H -DTIMEOUT -DRELEASE  -I. -I/home/parisse/casiolocal/include/ustl -DFILEICON -DKMALLOC  -DGINT_MALLOC -DTURTLETAB -DMICROPY_LIB #  #  -DNO_TEMPLATE_MULTGCD -DGIAC_GENERIC_CONSTANTS -fno-zero-initialized-in-bss -ffunction-sections -fdata-sections -ffast-math


LDFLAGS =  -g -static -nostdlib -Tprizm.ld -Wl,--gc-sections,--print-memory-usage
LDEMUFLAGS =  -g -static -nostdlib -Tprizmemu.ld -Wl,--gc-sections,--print-memory-usage

# pour voir les conflits entre fichiers objets
# nm archive.a -f posix | sed -E '/:$/ d; /[^ ]+ [a-zU]/ d; s/^([^ ]+).*$/\1/'
# sh3eb-elf-size *.o pour avoir les tailles
# zgen and zglobal were not upgraded to giac 1.7.0
CAS_OBJS = ksym2poly.o kgausspol.o kthreaded.o zcsturm.o zmaple.o zrpn.o zmoyal.o kmisc.o zpermu.o input_parser.o ksymbolic.o index.o kmodpoly.o kmodfactor.o kezgcd.o yderive.o ksolve.o kintg.o zintgab.o zlin.o zseries.o ksubst.o zvecteur.o zglobal.o zifactor.o kalg_ext.o zgauss.o zti89.o zplot.o zplot3d.o zprog.o kunary.o zusual.o kidentificateur.o zgen.o krisch.o input_lexer.o first.o zdesolve.o ztex.o zisom.o # memmgr.o mem.o

# old console: kmisc.cc should be compiled with -DOLD_CONSOLE
#GUI_OBJS = fileGUI.o inputGUI.o menuGUI.o textGUI.o fileProvider.o graphicsProvider.o stringsProvider.o history.o kdisplay.o dConsole.o dmain.o
# new console
GUI_OBJS = fileGUI.o menuGUI.o textGUI.o fileProvider.o graphicsProvider.o stringsProvider.o zdisplay.o console.o main.o

LIBS = -L. -L/home/parisse/casiolocal/lib -Wl,--start-group -ltommath -lmicropy  -lustl -lm -lc -lgcc -Wl,--end-group
#LIBS = -L. -L/home/parisse/casiolocal/lib -Wl,--start-group  -ltommath -lustl -lm -lc -lgcc -Wl,--end-group

.PRECIOUS: libcas.a libgui.a

all: khicas.g3a khicas.ac2 khicasm.g3a khicas.882 # encas.g3a encas.ac2 encasm.g3a encas.882 # pour la version console, supprimer le lien iostream -> iostream.new

%.o: %.cc
	$(CXX) $(CXXFLAGS) -c $<

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -c $<

libgui.a: $(GUI_OBJS)
	$(RM) -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

libcas.a: $(CAS_OBJS)
	$(RM) -f $@
	$(AR) cru $@ $^
	$(RANLIB) $@

mkhelp: mkhelp.cc
	c++ mkhelp.cc -o mkhelp

khelpfr.o: khelpfr.cc static_help.h mkhelp
	./mkhelp
	$(CXX) $(CXXFLAGS) -c khelpfr.cc -o khelpfr.o	

khelpen.o: khelpen.cc static_help.h
	./mkhelp
	$(CXX) $(CXXFLAGS) -c khelpfr.cc -o khelpfr.o	

khicas.elf: $(CAS_OBJS) $(GUI_OBJS) khelpfr.o catalogfr.o prizm.ld
	$(CXX) $(LDFLAGS) -Wl,-Map=khicas.map catalogfr.o  $(CAS_OBJS) khelpfr.o $(GUI_OBJS) $(LIBS) -o $@
	sh3eb-elf-objdump -C -t khicas.elf | sort > dump_t

khicasm.elf: $(CAS_OBJS) $(GUI_OBJS) khelpfr.o catalogfr.o prizmemu.ld
	$(CXX) $(LDEMUFLAGS) -Wl,-Map=khicasm.map catalogfr.o  $(CAS_OBJS) khelpfr.o $(GUI_OBJS) $(LIBS) -o $@
	sh3eb-elf-objdump -C -t khicasm.elf | sort > dumpm_t

OBJFLAGS= -O binary -R .bss -R .gint_bss -R .debug_info -R .debug_abbrev -R .debug_loc -R .debug_aranges -R .debug_ranges -R .debug_line -R .debug_str -R.comment -R  debug_frame
khicas.bin: khicas.elf prizm.ld
	$(OBJCOPY) $(OBJFLAGS) -R .rominram khicas.elf khicas.bin

khicas.ac2: khicas.elf prizm.ld
	$(OBJCOPY)  $(OBJFLAGS) -j .rominram khicas.elf khicas.ac2
	/bin/cp  khicas.ac2 /shared/tmp

khicas.g3a: khicas.bin
	mkg3a -n basic:Khicas -n internal:KHICAS -V 1.7.0 -i uns:khicasio.png -i sel:khicasio1.png $^ $@
	/bin/cp khicas.g3a /shared/tmp

khicasm.bin: khicasm.elf prizmemu.ld
	$(OBJCOPY) $(OBJFLAGS) -R .rominram khicasm.elf khicasm.bin

khicas.882: khicasm.elf prizmemu.ld
	$(OBJCOPY)  $(OBJFLAGS) -j .rominram khicasm.elf khicas.882
	/bin/cp  khicas.882 ~/.wine/drive_c

khicasm.g3a: khicasm.bin 
	mkg3a -n basic:Khicasm -n internal:KHICASM -V 1.7.0 -i uns:khicasio.png -i sel:khicasio1.png $^ $@
	/bin/cp khicasm.g3a ~/.wine/drive_c



encas.elf: $(CAS_OBJS) $(GUI_OBJS) khelpen.o catalogen.o prizm.ld
	$(CXX) $(LDFLAGS) -Wl,-Map=encas.map catalogen.o  $(CAS_OBJS) khelpfr.o $(GUI_OBJS) $(LIBS) -o $@
	sh3eb-elf-objdump -C -t encas.elf | sort > dump_t

encasm.elf: $(CAS_OBJS) $(GUI_OBJS) khelpen.o catalogen.o prizmemu.ld
	$(CXX) $(LDEMUFLAGS) -Wl,-Map=encasm.map catalogen.o  $(CAS_OBJS) khelpfr.o $(GUI_OBJS) $(LIBS) -o $@
	sh3eb-elf-objdump -C -t encasm.elf | sort > dumpm_t

OBJFLAGS= -O binary -R .bss -R .gint_bss -R .debug_info -R .debug_abbrev -R .debug_loc -R .debug_aranges -R .debug_ranges -R .debug_line -R .debug_str -R.comment -R  debug_frame
encas.bin: encas.elf prizm.ld
	$(OBJCOPY) $(OBJFLAGS) -R .rominram encas.elf encas.bin

encas.ac2: encas.elf prizm.ld
	$(OBJCOPY)  $(OBJFLAGS) -j .rominram encas.elf encas.ac2
	/bin/cp  encas.ac2 /shared/tmp

encas.g3a: encas.bin
	mkg3a -n basic:Encas -n internal:ENCAS -V 1.7.0 -i uns:khicasio.png -i sel:khicasio1.png $^ $@
	/bin/cp encas.g3a /shared/tmp

encasm.bin: encasm.elf prizmemu.ld
	$(OBJCOPY) $(OBJFLAGS) -R .rominram encasm.elf encasm.bin

encas.882: encasm.elf prizmemu.ld
	$(OBJCOPY)  $(OBJFLAGS) -j .rominram encasm.elf encas.882
	/bin/cp  encas.882 ~/.wine/drive_c

encasm.g3a: encasm.bin 
	mkg3a -n basic:Encasm -n internal:ENCASM -V 1.7.0 -i uns:khicasio.png -i sel:khicasio1.png $^ $@
	/bin/cp encasm.g3a ~/.wine/drive_c

clean:
	$(RM) -f *.o libcas.a libgui.a 
